> For the complete documentation index, see [llms.txt](https://developer.harness.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.harness.io/continuous-delivery/use-continuous-delivery/cd-building-blocks/executions/execution-history.md).

# Pipeline Execution History

This topic describes how to navigate to the execution history of pipelines and what information is contained within.

### Where Can I Find Execution History? <a href="#where-can-i-find-execution-history" id="where-can-i-find-execution-history"></a>

You can find the execution history of your pipeline or all pipelines in a project in the following places in the Harness UI.

#### Executions Tab <a href="#executions-tab" id="executions-tab"></a>

You can view the execution history of all pipelines for a given project in the **Executions** tab in the left navigation of the Harness UI:

![](/files/eAYwQyoF3rCGIXf6ebNO)

#### Pipelines Tab <a href="#pipelines-tab" id="pipelines-tab"></a>

You can view the execution history of all pipelines for a given project in the **Pipelines** tab also.

In the Harness UI left navigation, select **Pipelines**. A list of pipelines created under the project appears.

Select the more actions button on the right for the pipeline of your choice, and then select **View Executions**.

![](/files/e7HaubEvo3L06pnFPVGY)

#### Pipeline Studio <a href="#pipeline-studio" id="pipeline-studio"></a>

You can view the execution history of a specific pipeline using Pipeline Studio.

In the Harness UI left navigation, select **Pipelines**, and then select the pipeline for which you want to view the execution details.

Select the **Execution History** option on the top right corner of the page to view the execution details.

![](/files/RYpYYX9DYfIU0lBGerB6)

### Execution Reference <a href="#execution-reference" id="execution-reference"></a>

Each pipeline execution displays the following information.

* **Pipeline Name**
  * The name of the pipeline and execution ID.
  * When expanded, this column also shows the name of each stage in the pipeline.
* **Status**
  * Shows the status of the execution. The options are `SUCCESS`, `FAILED`, `ABORTED`, `EXPIRED`.
  * When expanded, this column shows the status of each stage as an emoji. You can hover over the emoji for more information.
* **Trigger Summary**
  * This column shows the origin of each execution.
  * The origin of each execution is the trigger type which initiated the pipeline execution.
* **Update Summary**

  * This column shows **execution information** for CD and Database DevOps modules.
  * The Update Summary behaves differently based on the module(s) used in the pipeline:

  | Module          | Information Shown                                                                       | Example                       | On-hover                                                                                                                                          |
  | --------------- | --------------------------------------------------------------------------------------- | ----------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------- |
  | CD              | The update summary for CD shows **Service → Environment** mappings.                     | `service1 → environment1`     | Hovering on the service name displays attached artifact version, tag, path and hovering on the environment name displays attached infrastructure. |
  | Database DevOps | The update summary for Database DevOps shows **Schema Version → DB Instance** mappings. | `schema_v34 → orders-db-prod` | Hovering on the schema version displays schema, hovering on the DB instance displays the DB instance and tag (if any).                            |

  * You can also visualize the mappings and view stage-wise execution details by simply expanding the card after clicking on the `chevron-right` icon as shown in the image below.

  ![](/files/APNxOGvDTPYvzNRqs6wd)

  * If there are more than three updates, let's say n updates, a `View all n updates` indicator appears, and clicking on it opens a popup which reveals the full list of stage-wise updates. The same popup can be opened by clicking on the `View Details` option which shows up when there are less than or equal to 3 updates. You can also navigate to the execution details using the `View Execution Details` option in this popup.

  ![](/files/qfQjqSjChnQl9Tm9sXPZ)
* **Execution Start Time**
  * Shows the user, method, and start time of the execution.
* **More details** The more details icon for each pipeline offers additional execution actions:
  * [Add Execution Notes](/harness-ai/use-harness-platform/pipelines/add-note-during-pipeline-execution.md)
  * Re-run from stage
  * View Execution
  * View Pipeline
  * [Re-run Pipeline](/harness-ai/use-harness-platform/pipelines/failure-handling/resume-pipeline-deployments.md)
  * [Abort Pipeline](/harness-ai/use-harness-platform/pipelines/failure-handling/abort-pipeline.md)
  * [View Compiled YAML](/harness-ai/use-harness-platform/pipelines/executions-and-logs/view-and-compare-pipeline-executions.md#view-compiled-yaml)
  * [Compare Pipeline Executions](/harness-ai/use-harness-platform/pipelines/executions-and-logs/view-and-compare-pipeline-executions.md#compare-executions)
  * [Download Logs](/harness-ai/use-harness-platform/pipelines/executions-and-logs/download-logs.md)

### Filter executions <a href="#filter-executions" id="filter-executions"></a>

You can filter pipeline executions using the filters in the **Execution History** or **Execution** tabs.

![](/files/ESlbhNw0pKn7iL3KD4s3)

You can filter pipeline execution based on **Status**, **Execution Mode**, **Trigger Type**, **Trigger Identifier**, **Timeframe**, **Deployment Type**, **Services**, **Environments**, **Artifacts** or **Build Type**.

#### Select your filters <a href="#select-your-filters" id="select-your-filters"></a>

{% tabs %}
{% tab title="Legacy Filter UI" %}
You can use default filter options show at the top such as **Status**, **Pipelines**, or **Select Repository**, or use more filter options by clicking the filter icon next to **Select a Saved Filter**.

![](/files/YtADRKcq1q1GK1EW7Dbx)

Here you can click **+New Filter** to create and store filters for future use.
{% endtab %}

{% tab title="New Filter UI" %}
{% hint style="info" %}
You can use the new filter UI by enabling the feature flag `CDS_EXECUTION_LIST_FILTERS`. Contact [Harness Support](mailto:support@harness.io) to enable this feature.
{% endhint %}

You can use default filter options such as **My Executions**, **Status**, or **Timeframe**, or use more filter options by clicking the **+Add Filter** button.

![](/files/jwfkkHDV8X4Tc5BOlf2h)

You can save your current filter settings by clicking **Save** and you can reference those saved filters by clicking the filter icon dropdown at the top right.
{% endtab %}
{% endtabs %}

***

#### Status <a href="#status" id="status"></a>

Filter pipeline execution based on Status of Pipeline Execution.

It includes:

* Aborted
* Aborted By Freeze
* Expired
* Failed
* Not Started
* Paused
* Queued
* Running
* Success
* Suspended
* Resource Waiting
* Async Waiting
* Skipped
* Task Waiting
* Timed Waiting
* Errored
* Ignore Failure
* Discontinuing
* Approval Rejected
* Intervention Waiting
* Approval Waiting
* Pausing
* Input Waiting
* Wait Step Running
* Queued License Limit Reached
* Queued Execution Concurrency Reached

#### View Execution History <a href="#view-execution-history" id="view-execution-history"></a>

By default, all executions, including re-runs and child pipelines from the last 30 days, will be listed in the execution view. If you want to view executions beyond 30 days, you can use the filter option available on the Execution page to select a custom time range. ![](/files/6dHje6VoAiVnfx3j2FyW)

{% hint style="info" %}
**IMPORTANT**

Pipeline execution data is retained for a maximum of 6 months. If you apply a filter to view executions within the last 6 months, the data will be accessible. However, any data older than 6 months will no longer be available.
{% endhint %}

#### Execution mode <a href="#execution-mode" id="execution-mode"></a>

Filter pipeline execution based on Execution mode:-

* **Default**: It shows the latest executions(of any retry) and normal execution(without retries) and rollbacks.
* **All**: It lists the old retries as well for the retried executions along with the default ones.
* **Rollback**: It only lists those executions which were executed in the rollback mode.

You can also reference execution mode in your pipeline using the expression `<+pipeline.executionMode>`. For more information, refer to [Pipeline expressions](/harness-ai/use-harness-platform/variables-and-expressions/harness-expressions-reference.md#pipeline-expressions)

#### Trigger type <a href="#trigger-type" id="trigger-type"></a>

Filter pipeline execution based on type of trigger.

It includes:

* MANUAL
* WEBHOOK
* WEBHOOK\_CUSTOM
* SCHEDULE\_CRON
* ARTIFACT
* MANIFEST

#### Trigger identifier <a href="#trigger-identifier" id="trigger-identifier"></a>

You can mention trigger identifiers to filter pipeline execution triggered by a particular trigger.

#### Timeframe <a href="#timeframe" id="timeframe"></a>

Filter pipeline execution based on time.

![](/files/eEjpgumrXMuGWasl17WR)

#### Deployment type <a href="#deployment-type" id="deployment-type"></a>

Filter pipeline execution based on the deployment type used in the pipeline.

It includes:

* Kubernetes
* Native Helm
* SSH
* WinRM
* Serverless Lambda
* Azure Web Apps
* Deployment Templates
* Amazon ECS
* Spot Elasticgroup
* Tanzu Application Service
* AWS Lambda
* AWS Sam

#### Services <a href="#services" id="services"></a>

You can filter the pipeline execution based on deployed services. Select your services from the drop-down list.

![](/files/PwQIUQsG4AJ8Ynbreo7C)

#### Environments <a href="#environments" id="environments"></a>

You can filter pipeline execution based on the environment to which you have deployed your service.

#### Artifacts <a href="#artifacts" id="artifacts"></a>

Filter pipeline execution based on artifacts.

#### Build type <a href="#build-type" id="build-type"></a>

Filter pipeline execution based on Build Type.

It includes:

* Pull Request/Merge Request
* Branch
* Tag

#### Execution Summary API <a href="#execution-summary-api" id="execution-summary-api"></a>

Harness provides an API to retrieve a summary of pipeline executions:

Sample cURL Command:

```
curl --location 'https://app.harness.io/gateway/pipeline/api/pipelines/execution/summary?routingId=vpCkHKsDSxK9_KYfjCTMKA&accountIdentifier=vpCkHKsDSxK9_KYfjCTMKA&projectIdentifier=<your-project-id>&orgIdentifier=<your-org-id>&pipelineIdentifier=<your-pipeline-id>global&page=0&size=20&sort=startTs%2CDESC&myDeployments=false&searchTerm=' \
--header 'Authorization: Bearer <your-auth-token>' \
--header 'Content-Type: application/json' \
--data '{"filterType":"PipelineExecution","myDeployments":false,"timeRange":{"timeRangeFilterType":"LAST_30_DAYS"},"moduleProperties":{"ci":{},"cd":{}}}'
```

**Result Limitations:**

Due to the underlying technical implementation, the API cannot retrieve records beyond the 10,000th execution, even if the page size is increased. If the results exceed this limit, an error will be encountered.

If this limitation is encountered, an error message will appear. Below is an example screenshot of the error message to help you identify the issue:

![](/files/SYshS8fh7SLAhKcHTZq9)

**Solution:**

To avoid encountering this limitation:

Apply additional filters, such as Status and Time Range, to narrow down the result set and reduce the number of executions listed. Refer to the [Pipeline Execution API](https://apidocs.harness.io/tag/Pipeline-Execution-Details#operation/getListOfExecutions) for more details. As an alternate, you can use the [Pipeline Execution Outline API](https://apidocs.harness.io/tag/Pipeline-Execution-Details#operation/getListOfExecutionsOutline).
